from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, File, String, Int

Describe_Cg_Py_V0_1_0 = CommandToolBuilder(tool="describe_cg.py", base_command=["describe_cg.py"], inputs=[ToolInput(tag="in_keep_length_one_stems", input_type=Boolean(optional=True), prefix="--keep-length-one-stems", doc=InputDocumentation(doc="For all input formats except forgi bg/cg files, this\ncontrolls whether stems of length one are dissolved to\nunpaired regions (default) or kept (if this option is\npresent). In the case of input in forgi-format, the\nRNA from the file is not modified.")), ToolInput(tag="in_csv", input_type=File(optional=True), prefix="--csv", doc=InputDocumentation(doc="Store dataframe under this filename. (Prints to stdout\nif not given)")), ToolInput(tag="in_keys", input_type=String(optional=True), prefix="--keys", doc=InputDocumentation(doc="Only print the following properties. (A comma-\nseperated list of column headers, e.g. rog_vres")), ToolInput(tag="in_angles", input_type=Int(optional=True), prefix="--angles", doc=InputDocumentation(doc="Store the angles between the given pairs of elements.\nComma-seperated element tuples, seperated by colons.\n(e.g.: 's0,s1:s1,s2')")), ToolInput(tag="in_distances", input_type=Int(optional=True), prefix="--distances", doc=InputDocumentation(doc="Store the distances between the given nucleotides.\nComma-seperated nucleotide tuples, seperated by\ncolons. (e.g.: '1,20:2,19')")), ToolInput(tag="in_per_ml", input_type=Boolean(optional=True), prefix="--per-ml", doc=InputDocumentation(doc="Describe junction segments instead of the whole cg\n(one entry per segment)")), ToolInput(tag="in_mode", input_type=File(optional=True), prefix="--mode", doc=InputDocumentation(doc="For use with --csv. Either 'a' for append or 'o' for\noverwrite. Default: Abort if file exists.")), ToolInput(tag="in_pseudo_knots", input_type=Boolean(optional=True), prefix="--pseudoknots", doc=InputDocumentation(doc="Allow pseudoknots when extracting the structure from\nPDB files.")), ToolInput(tag="in_chains", input_type=String(optional=True), prefix="--chains", doc=InputDocumentation(doc="When reading pdb-files: Only extract the given\nchain(s). Comma-seperated")), ToolInput(tag="in_pdb_secondary_structure", input_type=String(optional=True), prefix="--pdb-secondary-structure", doc=InputDocumentation(doc="When reading a single chain from a pdb-files: Enforce\nthe secondary structure given as dotbracket string.\n(This only works, if --chain is given!)")), ToolInput(tag="in_pdb_annotation_tool", input_type=File(optional=True), prefix="--pdb-annotation-tool", doc=InputDocumentation(doc="What program to use for detecting basepairs in PDB/\nMMCIF structures. This commandline option overrides\nthe value in the config file (if present).If this is\nnot present and no config-file is given, we try to\ndetect the installed programs.")), ToolInput(tag="in_pdb_allow_www_query", input_type=Boolean(optional=True), prefix="--pdb-allow-www-query", doc=InputDocumentation(doc="Usually, if modified residues/ ligand with an unknown\n3-letter code are encountered in PDB files, they are\nremoved from the chain and a log message of severity\nINFO is issued. With this option, we first try to\nquery the PDBeChem database for the 3-letter code, to\nsee whether or not it is a modified residue that can\nbe converted to its standard parent and should be part\nof the chain.")), ToolInput(tag="in_verbose", input_type=Boolean(optional=True), prefix="--verbose", doc=InputDocumentation(doc="Show verbose output (Output logged at level\nlogging.INFO)")), ToolInput(tag="in_debug", input_type=Boolean(optional=True), prefix="--debug", doc=InputDocumentation(doc="[DEBUG]       A comma-seperated list of logger names for which debug\noutput will be activated.WARNING: If you misspell the\nlogger name, this argument will be ignored")), ToolInput(tag="in_commaseperated_list_logger", input_type=Boolean(optional=True), prefix="-q", doc=InputDocumentation(doc="[QUIET], --quiet [QUIET]\nA comma-seperated list of logger names for which only\nmessages logged at the level 'CRITICAL' will be\nshown.Use this without arguments if everything should\nbe quiet.\n")), ToolInput(tag="in_rna", input_type=String(), position=0, doc=InputDocumentation(doc="One or more files containing one or more RNAs each.\nSupported Filetypes are: pdb files, forgi cg files,\nforgi bg files, fasta files,\ndotbracketfilesAlternatively you can supply a\ndotbracket-string (containing only the characters\n'.()[]{}&') from the commandline."))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Describe_Cg_Py_V0_1_0().translate("wdl", allow_empty_container=True)

